#! /bin/sh

DENY_HOST=""

/sbin/iptables -F
/sbin/iptables -X

/sbin/iptables -P INPUT DROP
/sbin/iptables -P OUTPUT ACCEPT
/sbin/iptables -P FORWARD DROP

echo "0" > /proc/sys/net/ipv4/ip_forward
echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_all
echo "1" > /proc/sys/net/ipv4/icmp_echo_ignore_broadcasts
echo "0" > /proc/sys/net/ipv4/conf/all/accept_source_route
echo "0" > /proc/sys/net/ipv4/conf/all/accept_redirects
echo "0" > /proc/sys/net/ipv4/conf/all/secure_redirects
echo "1" > /proc/sys/net/ipv4/icmp_ignore_bogus_error_responses
for i in /proc/sys/net/ipv4/conf/*/rp_filter; do
  echo "1" > $i
done
echo "1" > /proc/sys/net/ipv4/conf/all/log_martians
echo "1" > /proc/sys/net/ipv4/tcp_syncookies

/sbin/iptables -N deny_host
for host in $DENY_HOST
do
  /sbin/iptables -A deny_host -s $host -j LOG --log-prefix "iptables[deny_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
  /sbin/iptables -A deny_host -s $host -j DROP
  /sbin/iptables -A deny_host -d $host -j LOG --log-prefix "iptables[deny_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
  /sbin/iptables -A deny_host -d $host -j DROP
done

/sbin/iptables -N abroad_filter
while read line; do
  /sbin/iptables -A abroad_filter -s $line -j LOG --log-prefix "iptables[abroad_filter]: " --log-level debug -m limit --limit 5/second --limit-burst 10
  /sbin/iptables -A abroad_filter -s $line -j DROP
done < /usr/local/etc/delegated-apnic-latest


/sbin/iptables -N undesirable_host
/sbin/iptables -A undesirable_host -s 10.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 10.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -s 172.16.0.0/12    -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 172.16.0.0/12    -j DROP
#/sbin/iptables -A undesirable_host -s 192.168.0.0/16   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
#/sbin/iptables -A undesirable_host -s 192.168.0.0/16   -j DROP
/sbin/iptables -A undesirable_host -s 0.0.0.0/8        -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 0.0.0.0/8        -j DROP
/sbin/iptables -A undesirable_host -s 14.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 14.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -s 127.0.0.0/8      -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 127.0.0.0/8      -j DROP
/sbin/iptables -A undesirable_host -s 240.0.0.0/4      -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 240.0.0.0/4      -j DROP
/sbin/iptables -A undesirable_host -s 39.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 39.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -s 128.0.0.0/16     -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 128.0.0.0/16     -j DROP
/sbin/iptables -A undesirable_host -s 191.255.0.0/16   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 191.255.0.0/16   -j DROP
/sbin/iptables -A undesirable_host -s 192.0.0.0/24     -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 192.0.0.0/24     -j DROP
/sbin/iptables -A undesirable_host -s 223.255.255.0/24 -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 223.255.255.0/24 -j DROP
/sbin/iptables -A undesirable_host -s 24.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 24.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -s 169.254.0.0/16   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 169.254.0.0/16   -j DROP
/sbin/iptables -A undesirable_host -s 192.0.2.0/24     -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 192.0.2.0/24     -j DROP
/sbin/iptables -A undesirable_host -s 192.88.99.0/24   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 192.88.99.0/24   -j DROP
/sbin/iptables -A undesirable_host -s 198.18.0.0/15    -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 198.18.0.0/15    -j DROP
/sbin/iptables -A undesirable_host -s 224.0.0.0/4      -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -s 224.0.0.0/4      -j DROP
/sbin/iptables -A undesirable_host -d 10.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 10.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -d 172.16.0.0/12    -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 172.16.0.0/12    -j DROP
#/sbin/iptables -A undesirable_host -d 192.168.0.0/16   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
#/sbin/iptables -A undesirable_host -d 192.168.0.0/16   -j DROP
/sbin/iptables -A undesirable_host -d 0.0.0.0/8        -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 0.0.0.0/8        -j DROP
/sbin/iptables -A undesirable_host -d 14.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 14.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -d 127.0.0.0/8      -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 127.0.0.0/8      -j DROP
/sbin/iptables -A undesirable_host -d 240.0.0.0/4      -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 240.0.0.0/4      -j DROP
/sbin/iptables -A undesirable_host -d 39.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 39.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -d 128.0.0.0/16     -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 128.0.0.0/16     -j DROP
/sbin/iptables -A undesirable_host -d 191.255.0.0/16   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 191.255.0.0/16   -j DROP
/sbin/iptables -A undesirable_host -d 192.0.0.0/24     -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 192.0.0.0/24     -j DROP
/sbin/iptables -A undesirable_host -d 223.255.255.0/24 -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 223.255.255.0/24 -j DROP
/sbin/iptables -A undesirable_host -d 24.0.0.0/8       -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 24.0.0.0/8       -j DROP
/sbin/iptables -A undesirable_host -d 169.254.0.0/16   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 169.254.0.0/16   -j DROP
/sbin/iptables -A undesirable_host -d 192.0.2.0/24     -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 192.0.2.0/24     -j DROP
/sbin/iptables -A undesirable_host -d 192.88.99.0/24   -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 192.88.99.0/24   -j DROP
/sbin/iptables -A undesirable_host -d 198.18.0.0/15    -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 198.18.0.0/15    -j DROP
/sbin/iptables -A undesirable_host -d 224.0.0.0/4      -j LOG --log-prefix "iptables[undesirable_host]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A undesirable_host -d 224.0.0.0/4      -j DROP

/sbin/iptables -N broad_cast
/sbin/iptables -A broad_cast -d 255.255.255.255 -j LOG --log-prefix "iptables[broad_cast]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A broad_cast -d 255.255.255.255 -j DROP
/sbin/iptables -A broad_cast -d 244.0.0.1       -j LOG --log-prefix "iptables[broad_cast]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A broad_cast -d 244.0.0.1       -j DROP

/sbin/iptables -N check_flags
/sbin/iptables -A check_flags -p tcp --tcp-flags ACK,FIN FIN             -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ACK,FIN FIN             -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ACK,PSH PSH             -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ACK,PSH PSH             -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ACK,URG URG             -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ACK,URG URG             -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags FIN,RST FIN,RST         -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags FIN,RST FIN,RST         -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags SYN,FIN SYN,FIN         -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags SYN,FIN SYN,FIN         -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags SYN,RST SYN,RST         -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags SYN,RST SYN,RST         -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL ALL                 -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL ALL                 -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL NONE                -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL NONE                -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL FIN,PSH,URG         -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL FIN,PSH,URG         -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL SYN,FIN,PSH,URG     -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL SYN,FIN,PSH,URG     -j DROP
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j LOG --log-prefix "iptables[check_flags]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A check_flags -p tcp --tcp-flags ALL SYN,RST,ACK,FIN,URG -j DROP

/sbin/iptables -A INPUT -i lo -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m multiport --sports 135,137,138,139,445 -j DROP
/sbin/iptables -A INPUT -p udp -m multiport --sports 135,137,138,139,445 -j DROP
/sbin/iptables -A INPUT -p tcp -m multiport --dports 135,137,138,139,445 -j DROP
/sbin/iptables -A INPUT -p udp -m multiport --dports 135,137,138,139,445 -j DROP

/sbin/iptables -A INPUT -j deny_host
/sbin/iptables -A INPUT -j abroad_filter
/sbin/iptables -A INPUT -j undesirable_host
/sbin/iptables -A INPUT -m state --state INVALID -j DROP
/sbin/iptables -A INPUT -j check_flags
/sbin/iptables -A INPUT -m state --state ESTABLISHED,RELATED -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 80  -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 443 -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 8080 -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 25 -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 110 -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 22  -j ACCEPT
/sbin/iptables -A INPUT -p tcp --dport 53 -j ACCEPT
/sbin/iptables -A INPUT -p udp --dport 53 -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 21 -j ACCEPT
/sbin/iptables -A INPUT -p tcp -m state --state NEW --dport 65500:65535 -j ACCEPT
/sbin/iptables -A INPUT -p tcp --dport 113 -j REJECT --reject-with tcp-reset
/sbin/iptables -A INPUT -j LOG --log-prefix "iptables[drop]: " --log-level debug -m limit --limit 5/second --limit-burst 10
/sbin/iptables -A INPUT -j DROP
